#!/usr/bin/env python

# makes use of python serial. Install with:
# sudo apt-get install python3-serial

import os      # needed for file operations
import sys # Needed for handling command line parameters
import serial
import time

# FileName = "./tux-caveman_02_80x80.bmp"
# FileName = "./tux-caveman_02_300x300.bmp"
FileName = "./weilburg_02.bmp"
# FileName = "./test.bmp"
# FileName = "./test_02.bmp"
# FileName = "./black-square.bmp"

bfType = ""
bfSize = 0
bfReserved = 0
bfOffBits = 0
biSize = 0
biWidth = 0
biHeight = 0
biPlanes = 0
biBitCount = 0
biCompression = 0
biSizeImage = 0
biXPelsPerMeter = 0
biYPelsPerMeter = 0
biClrImportant = 0

pixelW = 0.251
pixelH = 0.251
feedRate = " F7000.000"

# gcodeFile = open("grbl.gcode", "w")


#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Sub open USB (grbl)
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
def open_USB():
    grbl = 0
    return grbl

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Sub write line to grbl
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
def write2grbl(grbl, command_line = "", wait_for_idle = 1):
    i = 0


#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Sub end grbl and exit
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
def exitScript():
    f.close()
    print("Script ended")
    sys.exit(0)



driveEdgesOnly = False
engraveOnly = False

for arg in sys.argv: # Loop through all command line parameters
    if arg == "-d" or arg == "--drive-edges-only":
        driveEdgesOnly = True

    elif arg == "-e" or arg == "--engrave-only":
        engraveOnly = True

# Look if the picture file exists
if os.path.isfile(FileName):
    print("Picture file detected, analyzing content")

    try:

        # Open the picture file
        f = open(FileName, "rb")
        bfType = f.read(2) # Read file identifyer
        if str(bfType) != "b'BM'":
            print("Header >" + str(bfType) + "< Not a bitmap file!")
        else:
            print("Bitmap ID detected")

        bfSize = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("bfSize =          ", format(bfSize, '10d'))

        bfReserved = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("bfReserved =      ", format(bfReserved, '10d'))

        bfOffBits = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("bfOffBits =       ", format(bfOffBits, '10d'))

        biSize = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("biSize =          ", format(biSize, '10d'))

        biWidth = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("biWidth =         ", format(biWidth, '10d'))

        biHeight = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("biHeight =        ", format(biHeight, '10d'))

        biPlanes = int.from_bytes(f.read(2), byteorder='little', signed=False)
        print("biPlanes =        ", format(biPlanes, '10d'))

        biBitCount = int.from_bytes(f.read(2), byteorder='little', signed=False)
        print("biBitCount =      ", format(biBitCount, '10d'))

        biCompression = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("biCompression =   ", format(biCompression, '10d'))

        biSizeImage = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("biSizeImage =     ", format(biSizeImage, '10d'))

        biXPelsPerMeter = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("biXPelsPerMeter = ", format(biXPelsPerMeter, '10d'))

        biYPelsPerMeter = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("biYPelsPerMeter = ", format(biYPelsPerMeter, '10d'))

        biClrUsed = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("biClrUsed =       ", format(biClrUsed, '10d'))

        biClrImportant = int.from_bytes(f.read(4), byteorder='little', signed=False)
        print("biClrImportant =  ", format(biClrImportant, '10d'))

        skipBytes = 0
        for i in range(bfOffBits - 54):# Skip bytes until bitmap data starts
            skipBytes = skipBytes + 1
            readByte = f.read(1)

        print("skipBytes =       ", format(skipBytes, '10d'))

        byteWidth = biWidth * biBitCount / 8
        while byteWidth % 4 != 0: # make byteWidth an integer of 4
            byteWidth = byteWidth + 1
        print("byteWidth =       ", format(int(byteWidth), '10d'))
        print("Empty bytes per line = ", int(byteWidth-biWidth*biBitCount/8))
        # Bitmap data starts here


        laserPower = 300
        dotCount = 0
        for currentPixelY in range(biHeight):
            print("Current line = ", currentPixelY + 1, " / ", biHeight)
            for currentPixelX in range(biWidth):
                pixelGrey = 255
                if biBitCount == 24: # True color
                    pixelR = int.from_bytes(f.read(1), byteorder='little', signed=False)
                    pixelG = int.from_bytes(f.read(1), byteorder='little', signed=False)
                    pixelB = int.from_bytes(f.read(1), byteorder='little', signed=False)
                    pixelGrey = (pixelR + pixelG + pixelB) / 3
                    #if pixelGrey > 254:
                    #    print(" ", end = '')
                    #else:
                    #    print("X", end = '')

                if biBitCount == 8: # Grey scale
                    pixelGrey = int.from_bytes(f.read(1), byteorder='little', signed=False)
                    #if pixelGrey > 128:
                    #    print(" ", end = '')
                    #else:
                    #    print("X", end = '')

                if(pixelGrey < 255):
                    dotCount = dotCount + 1


            #print("")
            for i in range(int(byteWidth-biWidth*biBitCount/8)):# Discard bytes
                byte_temp = f.read(1)



        print("Job done, " + str(dotCount) + " dots engraved!")
        exitScript()

    except Exception as e:
        print("An error has happened: ", e)

    except IOError: # Print message if a file error has happened
        print("Error handling Input/Output!")

    except KeyboardInterrupt:
        # This is the code section executed after 'ctrl+c' is pressed
        # Script ends after that section.
        print ("...keyboard interrupt detected\n")
        exitScript()

exit(0)


