#!/usr/bin/env python

# To make a Python script work on a web server,
# special text lines must be printed at the beginning:

print "Content-type: text/html\n\n" # double line ending needed!
print "<html><head>"
print ""
print "</head><body>"


# Make special commands available to your source code
# by importing code lines from outside this file

import RPi.GPIO as GPIO # needed to switch GPIOs
from time import sleep  # needed to make command "sleep" available


# Choose BOARD pin numbering
# On the Raspberry Pi, pin 1 ist the 3.3V pin on top left
# pin 2 is +5V pin on top right and so on.
# Only numbers that represent a GPIO pin are valid

GPIO.setmode(GPIO.BOARD)

# Set GPIO number 16 to output mode
GPIO.setup(16, GPIO.OUT)

# Define a variable and set it to 0
loopCount = 0

# Check if loopCount is lower than 3 and
# execute code below the while statement that is intended
# as long as that statement is true.
# In this example, the LED blinks as long as loopCount is lower than 3
# which is true for three loop runs

while (loopCount < 3):         # While statement must end with :
    
    # All code lines intended are executed
    # as long as the while condition above is TRUE.
    # If the condition is FALSE, those lines are skipped.
    
    GPIO.output(16, GPIO.HIGH) # Turn LED ON
    sleep(0.1)                 # Do nothing for 0.1 seconds
    GPIO.output(16, GPIO.LOW)  # Turn LED OFF
    sleep(1)                   # Do nothing for 1 second
    loopCount = loopCount + 1  # Increase loopCount by 1
    
    # Python now goes back to the while statement
    # and checks the condition again.
    # If that is FALSE, the program continues with the lines below.

# While loop ends here
# Blink LED once more, now on for 2 seconds

GPIO.output(16, GPIO.HIGH) # Turn LED ON
sleep(2)                   # Do nothing for 2 seconds
GPIO.output(16, GPIO.LOW)  # Turn LED OFF

# Finally print a message that the script has reached the end
print "...all done, end of script reached!"

# Finally a terminating text line must be printed to make the script
# work with a web server:

print "</body></html>"

